<template>
  <div class="flex flex-col h-full">
    <PageHeader
      show-search
      :loading="isLoading"
      @refresh="onPageRefresh"
      @search="value => term = value"
    />

    <Viewport
      :loading="isPaginationLoading"
      @fully-scrolled="onFullyScrolled"
    >
      <SwitchInput
        v-model="amenitiesStore.showArchived"
        label="Показывать архивные"
        :loading="isLoading"
      />

      <AmenitiesGridSkeleton v-if="isLoading" />
      <EmptyState v-if="!isLoading && !amenitiesStore.amenities.length" />

      <div
        v-show="amenitiesStore.amenities.length"
        class="grid gap-4 lg:gap-6 grid-cols-1 md:grid-cols-2 xl:grid-cols-3"
      >
        <v-slide-y-transition
          group
          leave-absolute
        >
          <section
            v-for="amenity in amenitiesStore.amenities"
            :key="amenity.id"
          >
            <AmenityEntity :data="amenity" />
          </section>
        </v-slide-y-transition>
      </div>
    </Viewport>
  </div>

  <CreateAmenityForm />
</template>

<script setup lang="ts">
import { onMounted, ref, watch } from 'vue';

import { AMENITIES_PAGE_SIZE } from '@/declarations';
import { usePagination } from '@/composables';
import { useAmenitiesStore } from '@/stores';

import PageHeader from '@/components/layout/PageHeader.vue';
import Viewport from '@/components/layout/Viewport.vue';
import EmptyState from '@/components/layout/EmptyState.vue';
import AmenitiesGridSkeleton from '@/components/skeletons/AmenitiesGridSkeleton.vue';

import SwitchInput from '@/components/content/SwitchInput.vue';

import AmenityEntity from './AmenityEntity.vue';
import CreateAmenityForm from './CreateAmenityForm.vue';

const pagination = usePagination({ size: AMENITIES_PAGE_SIZE });
const amenitiesStore = useAmenitiesStore();

const isLoading = ref(true);
const isPaginationLoading = ref(false);
const term = ref('');

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  if (options.useLoading) {
    isLoading.value = true;
  }

  await amenitiesStore.fetchData({
    reset: options.reset,
    limit: AMENITIES_PAGE_SIZE,
    offset: pagination.offset.value,
    ...(term.value && { term: term.value }),
  });

  isLoading.value = false;
};

const onPageRefresh = async () => {
  pagination.resetPage();
  await fetchData({ reset: true, useLoading: true });
};

const onFullyScrolled = async () => {
  isPaginationLoading.value = true;

  pagination.nextPage();
  await fetchData({ reset: false, useLoading: false });

  isPaginationLoading.value = false;
};

watch(term, () => {
  fetchData({ reset: true, useLoading: true });
  pagination.resetPage();
});

onMounted(() => fetchData({ reset: true, useLoading: true }));
</script>